open Monad.MonadList

let ei i n = 
 let a = Array.make n 0 in
 Array.set a (i-1) 1;
 Array.to_list a

let rec add = function
  | [],[] -> []
  | x :: xs, y :: ys -> (x + y) :: (add (xs,ys))
  | _ -> failwith "invalid arg in AC.add"

let zero n = Array.to_list (Array.make n 0)

let p_init m n =
  List.map
    (fun i -> ei i m, zero n)
    (Listx.interval 1 m)

let rec sum_lists = function 
  | [], [] -> 0
  | a :: aa, e::ee -> (a * e) + (sum_lists (aa,ee))
  | _ -> failwith "invalid arg in AC.sum_lists"

let d_of_p aa bb (px,py) = 
 (sum_lists (aa,px)) - (sum_lists (bb,py))

let rec less = function
  | [], [] -> true
  | a :: aa, b :: bb -> 
      if a <= b 
      then less (aa,bb) else false
  | _ -> failwith "invalid arg in AC.less"
	  

let minimal (px,py) mmm = 
 let p_mm1k = (px,py) :: (Listx.unique (List.flatten mmm)) in
 let sets =
   List.filter
     (fun (qx,qy) -> not (less (px,qx) && less (py,qy)))
     p_mm1k in
 sets = []
 

let rec delete xs ys = match xs,ys with
  | []   ,_  -> []
  | xs   ,[] -> xs
  | x::xs,ys ->
      if List.mem x ys then
        delete xs (Listx.remove x ys)
      else
        x :: delete xs ys
 
let rec complete (d,m,n) pp mm mmm qq = 
  if pp = [] then Listx.unique (List.flatten mmm)
  else 
    let positive =
      let* (px,py) = pp in
      guard (d (px,py) > 0) >>= fun () ->
      let* j = Listx.interval 1 n in
      [px, (add (py,(ei j n)))] in
    let negative =
      let* (px,py) = pp in
      guard (d (px,py) < 0) >>= fun () ->
      let* i = Listx.interval 1 m in
      [(add (px,(ei i m))), py] in
    let qqk = Listx.unique (positive @ negative) in                                  
    let mmk = List.filter (fun p -> d p = 0) qqk in
    let ppk = List.filter (fun p -> minimal p mmm) (delete qqk mmk) in
    complete (d,m,n) ppk mmk (mmk :: mmm) qqk

    
let basis aa bb = 
  if aa = [] && bb = [] then
    [ ([],[]) ]
  else
    let m = List.length aa in
    let n = List.length bb in 
    let d = d_of_p aa bb in 
    complete (d,m,n) (p_init m n) [] [[]] []
